<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>GStreamer Good Plugins 1.0 Plugins Reference Manual: deinterlace</title>
<meta name="generator" content="DocBook XSL Stylesheets V1.78.1">
<link rel="home" href="index.html" title="GStreamer Good Plugins 1.0 Plugins Reference Manual">
<link rel="up" href="ch01.html" title="gst-plugins-good Elements">
<link rel="prev" href="gst-plugins-good-plugins-dcaparse.html" title="dcaparse">
<link rel="next" href="gst-plugins-good-plugins-deinterleave.html" title="deinterleave">
<meta name="generator" content="GTK-Doc V1.20 (XML mode)">
<link rel="stylesheet" href="style.css" type="text/css">
</head>
<body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF">
<table class="navigation" id="top" width="100%" summary="Navigation header" cellpadding="2" cellspacing="10"><tr valign="middle">
<td width="100%" align="left" class="shortcuts">
<a href="#" class="shortcut">Top</a><span id="nav_description"> <span class="dim">|</span> 
                  <a href="#gst-plugins-good-plugins-deinterlace.description" class="shortcut">Description</a></span><span id="nav_hierarchy"> <span class="dim">|</span> 
                  <a href="#gst-plugins-good-plugins-deinterlace.object-hierarchy" class="shortcut">Object Hierarchy</a></span><span id="nav_interfaces"> <span class="dim">|</span> 
                  <a href="#gst-plugins-good-plugins-deinterlace.implemented-interfaces" class="shortcut">Implemented Interfaces</a></span><span id="nav_properties"> <span class="dim">|</span> 
                  <a href="#gst-plugins-good-plugins-deinterlace.properties" class="shortcut">Properties</a></span>
</td>
<td><a accesskey="h" href="index.html"><img src="home.png" width="16" height="16" border="0" alt="Home"></a></td>
<td><a accesskey="u" href="ch01.html"><img src="up.png" width="16" height="16" border="0" alt="Up"></a></td>
<td><a accesskey="p" href="gst-plugins-good-plugins-dcaparse.html"><img src="left.png" width="16" height="16" border="0" alt="Prev"></a></td>
<td><a accesskey="n" href="gst-plugins-good-plugins-deinterleave.html"><img src="right.png" width="16" height="16" border="0" alt="Next"></a></td>
</tr></table>
<div class="refentry">
<a name="gst-plugins-good-plugins-deinterlace"></a><div class="titlepage"></div>
<div class="refnamediv"><table width="100%"><tr>
<td valign="top">
<h2><span class="refentrytitle"><a name="gst-plugins-good-plugins-deinterlace.top_of_page"></a>deinterlace</span></h2>
<p>deinterlace — Deinterlace Methods ported from DScaler/TvTime</p>
</td>
<td class="gallery_image" valign="top" align="right"></td>
</tr></table></div>
<div class="refsect1">
<a name="gst-plugins-good-plugins-deinterlace.properties"></a><h2>Properties</h2>
<div class="informaltable"><table border="0">
<colgroup>
<col width="150px" class="properties_type">
<col width="300px" class="properties_name">
<col width="200px" class="properties_flags">
</colgroup>
<tbody>
<tr>
<td class="property_type"><span class="type">GstDeinterlaceFields</span></td>
<td class="property_name"><a class="link" href="gst-plugins-good-plugins-deinterlace.html#GstDeinterlace--fields" title="The “fields” property">fields</a></td>
<td class="property_flags">Read / Write</td>
</tr>
<tr>
<td class="property_type"><span class="type">GstDeinterlaceMethods</span></td>
<td class="property_name"><a class="link" href="gst-plugins-good-plugins-deinterlace.html#GstDeinterlace--method" title="The “method” property">method</a></td>
<td class="property_flags">Read / Write</td>
</tr>
<tr>
<td class="property_type"><span class="type">GstDeinterlaceModes</span></td>
<td class="property_name"><a class="link" href="gst-plugins-good-plugins-deinterlace.html#GstDeinterlace--mode" title="The “mode” property">mode</a></td>
<td class="property_flags">Read / Write</td>
</tr>
<tr>
<td class="property_type"><span class="type">GstDeinterlaceFieldLayout</span></td>
<td class="property_name"><a class="link" href="gst-plugins-good-plugins-deinterlace.html#GstDeinterlace--tff" title="The “tff” property">tff</a></td>
<td class="property_flags">Read / Write</td>
</tr>
<tr>
<td class="property_type"><a href="http://library.gnome.org/devel/glib/unstable/glib-Basic-Types.html#gboolean"><span class="type">gboolean</span></a></td>
<td class="property_name"><a class="link" href="gst-plugins-good-plugins-deinterlace.html#GstDeinterlace--drop-orphans" title="The “drop-orphans” property">drop-orphans</a></td>
<td class="property_flags">Read / Write</td>
</tr>
<tr>
<td class="property_type"><a href="http://library.gnome.org/devel/glib/unstable/glib-Basic-Types.html#gboolean"><span class="type">gboolean</span></a></td>
<td class="property_name"><a class="link" href="gst-plugins-good-plugins-deinterlace.html#GstDeinterlace--ignore-obscure" title="The “ignore-obscure” property">ignore-obscure</a></td>
<td class="property_flags">Read / Write</td>
</tr>
<tr>
<td class="property_type"><span class="type">GstDeinterlaceLocking</span></td>
<td class="property_name"><a class="link" href="gst-plugins-good-plugins-deinterlace.html#GstDeinterlace--locking" title="The “locking” property">locking</a></td>
<td class="property_flags">Read / Write</td>
</tr>
</tbody>
</table></div>
</div>
<a name="GstDeinterlace"></a><div class="refsect1">
<a name="gst-plugins-good-plugins-deinterlace.other"></a><h2>Types and Values</h2>
<div class="informaltable"><table width="100%" border="0">
<colgroup>
<col width="150px" class="name">
<col class="description">
</colgroup>
<tbody><tr>
<td class="datatype_keyword">struct</td>
<td class="function_name"><a class="link" href="gst-plugins-good-plugins-deinterlace.html#GstDeinterlace-struct" title="struct GstDeinterlace">GstDeinterlace</a></td>
</tr></tbody>
</table></div>
</div>
<div class="refsect1">
<a name="gst-plugins-good-plugins-deinterlace.object-hierarchy"></a><h2>Object Hierarchy</h2>
<pre class="screen">    <a href="http://library.gnome.org/devel/gobject/unstable/gobject-The-Base-Object-Type.html#GObject">GObject</a>
    <span class="lineart">╰──</span> <a href="http://library.gnome.org/devel/gobject/unstable/gobject-The-Base-Object-Type.html#GInitiallyUnowned">GInitiallyUnowned</a>
        <span class="lineart">╰──</span> <a href="http://gstreamer.freedesktop.org/data/doc/gstreamer/head/gstreamer/html/GstObject.html">GstObject</a>
            <span class="lineart">╰──</span> <a href="http://gstreamer.freedesktop.org/data/doc/gstreamer/head/gstreamer/html/GstElement.html">GstElement</a>
                <span class="lineart">╰──</span> GstDeinterlace
</pre>
</div>
<div class="refsect1">
<a name="gst-plugins-good-plugins-deinterlace.implemented-interfaces"></a><h2>Implemented Interfaces</h2>
<p>
GstDeinterlace implements
 <a href="http://gstreamer.freedesktop.org/data/doc/gstreamer/head/gstreamer/html/GstChildProxy.html">GstChildProxy</a>.</p>
</div>
<div class="refsect1">
<a name="gst-plugins-good-plugins-deinterlace.description"></a><h2>Description</h2>
<p>deinterlace deinterlaces interlaced video frames to progressive video frames.
For this different algorithms can be selected which will be described later.</p>
<div class="refsect2">
<a name="id-1.2.40.8.3"></a><h3>Example launch line</h3>
<div class="informalexample">
  <table class="listing_frame" border="0" cellpadding="0" cellspacing="0">
    <tbody>
      <tr>
        <td class="listing_lines" align="right"><pre>1</pre></td>
        <td class="listing_code"><pre class="programlisting">gst<span class="gtkdoc opt">-</span>launch<span class="gtkdoc opt">-</span><span class="number">1.0</span> <span class="gtkdoc opt">-</span>v filesrc location<span class="gtkdoc opt">=/</span>path<span class="gtkdoc opt">/</span>to<span class="gtkdoc opt">/</span>file <span class="gtkdoc opt">!</span> decodebin2 <span class="gtkdoc opt">!</span> videoconvert <span class="gtkdoc opt">!</span> deinterlace <span class="gtkdoc opt">!</span> videoconvert <span class="gtkdoc opt">!</span> autovideosink</pre></td>
      </tr>
    </tbody>
  </table>
</div>
 This pipeline deinterlaces a video file with the default deinterlacing options.
</div>
<div class="refsynopsisdiv">
<h2>Synopsis</h2>
<div class="refsect2">
<a name="id-1.2.40.8.4.1"></a><h3>Element Information</h3>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term">plugin</span></p></td>
<td>
            <a class="link" href="gst-plugins-good-plugins-plugin-deinterlace.html#plugin-deinterlace">deinterlace</a>
          </td>
</tr>
<tr>
<td><p><span class="term">author</span></p></td>
<td>Martin Eikermann &lt;meiker@upb.de&gt;, Sebastian Dröge &lt;sebastian.droege@collabora.co.uk&gt;</td>
</tr>
<tr>
<td><p><span class="term">class</span></p></td>
<td>Filter/Effect/Video/Deinterlace</td>
</tr>
</tbody>
</table></div>
</div>
<hr>
<div class="refsect2">
<a name="id-1.2.40.8.4.2"></a><h3>Element Pads</h3>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term">name</span></p></td>
<td>sink</td>
</tr>
<tr>
<td><p><span class="term">direction</span></p></td>
<td>sink</td>
</tr>
<tr>
<td><p><span class="term">presence</span></p></td>
<td>always</td>
</tr>
<tr>
<td><p><span class="term">details</span></p></td>
<td>video/x-raw, format=(string){ AYUV, ARGB, ABGR, RGBA, BGRA, Y444, xRGB, xBGR, RGBx, BGRx, RGB, BGR, YUY2, YVYU, UYVY, Y42B, I420, YV12, Y41B, NV12, NV21 }, width=(int)[ 1, 2147483647 ], height=(int)[ 1, 2147483647 ], framerate=(fraction)[ 0/1, 2147483647/1 ]</td>
</tr>
<tr>
<td><p><span class="term"></span></p></td>
<td> video/x-raw(ANY), format=(string){ I420, YV12, YUY2, UYVY, AYUV, RGBx, BGRx, xRGB, xBGR, RGBA, BGRA, ARGB, ABGR, RGB, BGR, Y41B, Y42B, YVYU, Y444, v210, v216, NV12, NV21, NV16, NV24, GRAY8, GRAY16_BE, GRAY16_LE, v308, RGB16, BGR16, RGB15, BGR15, UYVP, A420, RGB8P, YUV9, YVU9, IYU1, ARGB64, AYUV64, r210, I420_10LE, I420_10BE, I422_10LE, I422_10BE, Y444_10LE, Y444_10BE, GBR, GBR_10LE, GBR_10BE, NV12_64Z32 }, width=(int)[ 1, 2147483647 ], height=(int)[ 1, 2147483647 ], framerate=(fraction)[ 0/1, 2147483647/1 ]</td>
</tr>
</tbody>
</table></div>
<div class="variablelist"><table border="0" class="variablelist">
<colgroup>
<col align="left" valign="top">
<col>
</colgroup>
<tbody>
<tr>
<td><p><span class="term">name</span></p></td>
<td>src</td>
</tr>
<tr>
<td><p><span class="term">direction</span></p></td>
<td>source</td>
</tr>
<tr>
<td><p><span class="term">presence</span></p></td>
<td>always</td>
</tr>
<tr>
<td><p><span class="term">details</span></p></td>
<td>video/x-raw, format=(string){ AYUV, ARGB, ABGR, RGBA, BGRA, Y444, xRGB, xBGR, RGBx, BGRx, RGB, BGR, YUY2, YVYU, UYVY, Y42B, I420, YV12, Y41B, NV12, NV21 }, width=(int)[ 1, 2147483647 ], height=(int)[ 1, 2147483647 ], framerate=(fraction)[ 0/1, 2147483647/1 ]</td>
</tr>
<tr>
<td><p><span class="term"></span></p></td>
<td> video/x-raw(ANY), format=(string){ I420, YV12, YUY2, UYVY, AYUV, RGBx, BGRx, xRGB, xBGR, RGBA, BGRA, ARGB, ABGR, RGB, BGR, Y41B, Y42B, YVYU, Y444, v210, v216, NV12, NV21, NV16, NV24, GRAY8, GRAY16_BE, GRAY16_LE, v308, RGB16, BGR16, RGB15, BGR15, UYVP, A420, RGB8P, YUV9, YVU9, IYU1, ARGB64, AYUV64, r210, I420_10LE, I420_10BE, I422_10LE, I422_10BE, Y444_10LE, Y444_10BE, GBR, GBR_10LE, GBR_10BE, NV12_64Z32 }, width=(int)[ 1, 2147483647 ], height=(int)[ 1, 2147483647 ], framerate=(fraction)[ 0/1, 2147483647/1 ]</td>
</tr>
</tbody>
</table></div>
</div>
</div>
<p>
</p>
</div>
<div class="refsect1">
<a name="gst-plugins-good-plugins-deinterlace.functions_details"></a><h2>Functions</h2>
</div>
<div class="refsect1">
<a name="gst-plugins-good-plugins-deinterlace.other_details"></a><h2>Types and Values</h2>
<div class="refsect2">
<a name="GstDeinterlace-struct"></a><h3>struct GstDeinterlace</h3>
<pre class="programlisting">struct GstDeinterlace;</pre>
<p>
</p>
</div>
</div>
<div class="refsect1">
<a name="gst-plugins-good-plugins-deinterlace.property-details"></a><h2>Property Details</h2>
<div class="refsect2">
<a name="GstDeinterlace--fields"></a><h3>The <code class="literal">“fields”</code> property</h3>
<pre class="programlisting">  “fields”                   <span class="type">GstDeinterlaceFields</span></pre>
<p>This selects which fields should be output. If "all" is selected
the output framerate will be double.</p>
<p>Flags: Read / Write</p>
<p>Default value: All fields</p>
</div>
<hr>
<div class="refsect2">
<a name="GstDeinterlace--method"></a><h3>The <code class="literal">“method”</code> property</h3>
<pre class="programlisting">  “method”                   <span class="type">GstDeinterlaceMethods</span></pre>
<p>Selects the different deinterlacing algorithms that can be used.
These provide different quality and CPU usage.</p>
<p>Some methods provide parameters which can be set by getting
the "method" child via the <a href="http://gstreamer.freedesktop.org/data/doc/gstreamer/head/gstreamer/html/GstChildProxy.html"><span class="type">GstChildProxy</span></a> interface and
setting the appropiate properties on it.</p>
<div class="itemizedlist"><ul class="itemizedlist" style="list-style-type: disc; ">
<li class="listitem"><p>
tomsmocomp
Motion Adaptive: Motion Search
</p></li>
<li class="listitem"><p>
greedyh
Motion Adaptive: Advanced Detection
</p></li>
<li class="listitem"><p>
greedyl
Motion Adaptive: Simple Detection
</p></li>
<li class="listitem"><p>
vfir
Blur vertical
</p></li>
<li class="listitem"><p>
linear
Linear interpolation
</p></li>
<li class="listitem"><p>
linearblend
Linear interpolation in time domain.  Any motion causes significant
ghosting, so this method should not be used.
</p></li>
<li class="listitem"><p>
scalerbob
Double lines
</p></li>
<li class="listitem"><p>
weave
Weave.  Bad quality, do not use.
</p></li>
<li class="listitem"><p>
weavetff
Progressive: Top Field First.  Bad quality, do not use.
</p></li>
<li class="listitem"><p>
weavebff
Progressive: Bottom Field First.  Bad quality, do not use.
</p></li>
</ul></div>
<p>Flags: Read / Write</p>
<p>Default value: Television: Full resolution</p>
</div>
<hr>
<div class="refsect2">
<a name="GstDeinterlace--mode"></a><h3>The <code class="literal">“mode”</code> property</h3>
<pre class="programlisting">  “mode”                     <span class="type">GstDeinterlaceModes</span></pre>
<p>This selects whether the deinterlacing methods should
always be applied or if they should only be applied
on content that has the "interlaced" flag on the caps.</p>
<p>Flags: Read / Write</p>
<p>Default value: Auto detection</p>
</div>
<hr>
<div class="refsect2">
<a name="GstDeinterlace--tff"></a><h3>The <code class="literal">“tff”</code> property</h3>
<pre class="programlisting">  “tff”                      <span class="type">GstDeinterlaceFieldLayout</span></pre>
<p>Deinterlace top field first.</p>
<p>Flags: Read / Write</p>
<p>Default value: Auto detection</p>
</div>
<hr>
<div class="refsect2">
<a name="GstDeinterlace--drop-orphans"></a><h3>The <code class="literal">“drop-orphans”</code> property</h3>
<pre class="programlisting">  “drop-orphans”             <a href="http://library.gnome.org/devel/glib/unstable/glib-Basic-Types.html#gboolean"><span class="type">gboolean</span></a></pre>
<p>This selects whether to drop orphan fields at the beginning of telecine
patterns in active locking mode.</p>
<p>Flags: Read / Write</p>
<p>Default value: TRUE</p>
</div>
<hr>
<div class="refsect2">
<a name="GstDeinterlace--ignore-obscure"></a><h3>The <code class="literal">“ignore-obscure”</code> property</h3>
<pre class="programlisting">  “ignore-obscure”           <a href="http://library.gnome.org/devel/glib/unstable/glib-Basic-Types.html#gboolean"><span class="type">gboolean</span></a></pre>
<p>This selects whether to ignore obscure/rare telecine patterns.
NTSC 2:3 pulldown variants are the only really common patterns.</p>
<p>Flags: Read / Write</p>
<p>Default value: TRUE</p>
</div>
<hr>
<div class="refsect2">
<a name="GstDeinterlace--locking"></a><h3>The <code class="literal">“locking”</code> property</h3>
<pre class="programlisting">  “locking”                  <span class="type">GstDeinterlaceLocking</span></pre>
<p>This selects which approach to pattern locking is used which affects
processing latency and accuracy of timestamp adjustment for telecine
streams.</p>
<p>Flags: Read / Write</p>
<p>Default value: No pattern locking</p>
</div>
</div>
</div>
<div class="footer">
<hr>
          Generated by GTK-Doc V1.20</div>
</body>
</html>